
$regfile = "m32def.dat"                                     ' specify the used micro

$crystal = 1000000                                          ' used crystal frequency

$baud = 4800                                                ' use baud rate

$hwstack = 100                                              ' default use 32 for the hardware stack
$swstack = 100                                              ' default use 10 for the SW stack
$framesize = 60

Waitms 500


'Alles fuer den EEPROM
Const E_ctlw = &B1010_0000
Const E_ctlr = &B1010_0001
Config Scl = Portc.0
Config Sda = Portc.1
Dim E_ah As Byte
Dim E_al As Byte
Dim Sbyte_single(4) As Byte
Dim Single_wert As Single At Sbyte_single Overlay
Dim Sbyte_int(2) As Byte
Dim Int_wert As Integer At Sbyte_int Overlay

Dim S1 As Byte
Dim S2 As Byte
Dim S3 As Byte
Dim S4 As Byte

Declare Sub E_write(byval Speicherzelle_pos As Word , Dat As Byte)
Declare Sub E_read(byval Speicherzelle_pos As Word , E_dat As Byte)
Declare Sub Intspeicher(byval Start_speicherzelle As Word , Intueber As Integer)
Declare Sub Intlese(byval Start_speicherzelle As Word , Intueber As Integer)
Declare Sub Singlespeicher(byval Start_speicherzelle As Word , Singleueber As Single)
Declare Sub Singlelese(byval Start_speicherzelle As Word , Singleueber As Single)

'Enable Interrupts
Config Lcdbus = 4
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portb.4 , Rs = Portb.5

Config Lcd = 16 * 2                                         'configure lcd screen

Config Portb.6 = Output
Led Alias Portb.6
Config Porta.2 = Output
Rxgps Alias Porta.2
Config Porta.1 = Output
Txgps Alias Porta.1
Config Portd.7 = Output
Rxpc Alias Portd.7
Config Porta.3 = Output
Txpc Alias Porta.3
'config porta.2 = output
'GPS_Schalter alias porta.2
Config Pina.0 = Input
Schalter Alias Pina.0


Dim Eingabestring As String * 80
Dim Eingabestring2 As String * 80

Dim Sucher As String * 6
Dim Sucher2 As String * 1
Dim Suchergros1 As String * 10
Dim Suchergros2 As String * 10

Dim Position As Byte
Dim Position1 As Byte
Dim Position2 As Byte

Dim Komma1 As Byte
Dim Komma2 As Byte
Dim Komma3 As Byte
Dim Komma4 As Byte
Dim Komma5 As Byte
Dim Komma6 As Byte
Dim Komma7 As Byte
Dim Komma8 As Byte
Dim Komma9 As Byte
Dim Komma10 As Byte

Dim Nordwert As Single
Dim Nordwert_i As Integer
Dim Nordwert2 As Single
Dim Nordwert3 As Single
Dim Ostwert As Single
Dim Ostwert2 As Single
Dim Ostwert3 As Single
Dim Ostwert_i As Integer
Dim Uhrzeit As Single
Dim Hoehe As Integer
Dim Orts_versatz As Single
Dim Orts_versatz_i As Integer
Dim Orts_versatz_alt As Single

Dim Real_versatz As Single
Dim Vorgabe_versatz As Single
Dim Laengenminute As Single
Dim Zwischenspeicher As Single
Dim Zwischenspeicher2 As Single
Dim Genauigkeit As Single

Dim Uhrzeit_ar(120)as Integer
Dim Hoehe_ar(120)as Integer
Dim Norden_ar(120)as Single
Dim Osten_ar(120)as Single

Dim Abgefragt As Bit
Dim Wertschreiben As Bit
Dim Eingestellt As Bit

Dim Zahler As Integer
Dim Zahler2 As Byte
Dim Zahler3 As Integer
Dim Zahler5 As Integer
Dim Ortszahler As Integer
Dim Arrayzahler As Integer , Arrayzahlerx As Eram Integer

Dim Zahler4 As Byte
Dim Scrolldisplay As Byte

Dim Startzahler As Long , Startzahlerx As Eram Long
Dim Speicherzelle As Byte , Speicherzellex As Eram Byte
Dim Speicherzelle_pos As Word , Speicherzellex_pos As Eram Word
Dim Zurueckgelegte_strecke As Long , Zurueckgelegte_streckex As Eram Long
Dim Zurueckgelegte_strecke2 As Long
Dim Speicherzelle_pos2 As Word
Dim Eeprom_groesse As Long , Eeprom_groesse_x As Eram Long

Dim Zusatzinformationx As Eram String * 40
Dim Vorgabe_versatzx As Eram Single
Dim Vorgabe_genauigkeit As Single
Dim Vorgabe_genauigkeitx As Eram Single
Dim Test_ok As Byte
Dim E_dat As Byte
Dim Dat As Byte
Dim E_addr As Word

Cursor Off
'Lesen aus dem Eeprom
Startzahler = Startzahlerx
Speicherzelle = Speicherzellex
Speicherzelle_pos = Speicherzellex_pos
Zurueckgelegte_strecke = Zurueckgelegte_streckex
Arrayzahler = Arrayzahlerx
Eeprom_groesse = Eeprom_groesse_x

If Startzahler <= 0 Then
'Erster Start nach Beschreiben
Eeprom_groesse = 5333
Eeprom_groesse_x = Eeprom_groesse

Arrayzahler = 1
Arrayzahlerx = Arrayzahler

Startzahler = Startzahler + 1
Startzahlerx = Startzahler
'Festlegen der Grundeinstellungen
Zurueckgelegte_strecke = 0
Zurueckgelegte_streckex = Zurueckgelegte_strecke
'Speicherzellenposition nullen
Speicherzelle_pos = &H0010
Speicherzellex_pos = Speicherzelle_pos
'Speicherzelle, auf der Daten abgelegt werden
'EEPROM=1, Intern=2
Speicherzelle = 1
Speicherzellex = Speicherzelle
'vorgabe_versatz in Meter, ab dem augelst wird
Vorgabe_versatz = 30
Vorgabe_versatzx = Vorgabe_versatz
Vorgabe_genauigkeit = 3
Vorgabe_genauigkeitx = Vorgabe_genauigkeit
'Zusatzinformation
Eingabestring = "******mikrocontroller.net Version******"

Zusatzinformationx = Eingabestring
End If


'EEPROM-TEST
Test_ok = 1
Dat = 0

While E_addr < &H0010
Call E_write(e_addr , Dat)
Call E_read(e_addr , E_dat)
If E_dat = Dat Then
Else
Test_ok = 0
End If
Dat = Dat + 1
Incr E_addr
Wend

Locate 1 , 1
If Test_ok = 1 Then
Lcd "EEPROM OK!"
Else
Lcd "EEPROM FEHLER!"
Eeprom_groesse = 0
Waitms 2000
End If

Locate 1 , 1
Lcd "POSLOG 0.3|" ; Startzahler

Startzahler = Startzahler + 1
Startzahlerx = Startzahler

Deflcdchar 0 , 31 , 23 , 19 , 17 , 17 , 19 , 23 , 31        'Pfeil

Vorgabe_versatz = Vorgabe_versatzx
Vorgabe_genauigkeit = Vorgabe_genauigkeitx


If Schalter = 0 Then
Rxgps = 1
Txgps = 1
Rxpc = 0
Txpc = 0
'GPS_Schalter=1
Abgefragt = 0
Else
Rxgps = 0
Txgps = 0
Rxpc = 1
Txpc = 1
'GPS_Schalter=0
End If

For Zahler4 = 1 To 16
Locate 2 , Zahler4
Lcd Chr(0)
Waitms 150
Next Zahler4


Wertschreiben = 0
Scrolldisplay = 1

Do
If Schalter = 0 Then
'GPS_Schalter=1
If Abgefragt = 1 Then
Rxgps = 1
Txgps = 1
Rxpc = 0
Txpc = 0
Abgefragt = 0
Waitms 500
End If

Input Eingabestring Noecho
Toggle Led
Abgefragt = 0
Sucher = "$GPGGA"
Position = Instr(eingabestring , Sucher)
If Position > 0 Then


Zahler = 79
Zahler2 = 0

While Zahler > 1
Sucher2 = ""
Position1 = Zahler
Eingabestring2 = Right(eingabestring , Position1)
Sucher2 = Left(eingabestring2 , 1)
If Sucher2 = "," Then
Incr Zahler2

'Zahler2-Zustnde
'1=Uhrzeit
'2=Norden
'3=N
'4=Osten
'5=E
'6=Position Fix Indicator (0=not available|1-3=valid)
'7=Satelittenanzahl
'8=Genauigkeit
'9=Hhe


If Zahler2 = 1 Then
Komma1 = Position1 - 1
End If

If Zahler2 = 2 Then
Komma2 = Position1 - 1
End If

If Zahler2 = 3 Then
Komma3 = Position1 - 1
End If

If Zahler2 = 4 Then
Komma4 = Position1 - 1
End If

If Zahler2 = 5 Then
Komma5 = Position1 - 1
End If

If Zahler2 = 6 Then
Komma6 = Position1 - 1
End If

If Zahler2 = 7 Then
Komma7 = Position1 - 1
End If

If Zahler2 = 8 Then
Komma8 = Position1 - 1
End If

If Zahler2 = 9 Then
Komma9 = Position1 - 1
End If

If Zahler2 = 10 Then
Komma10 = Position1 - 1
End If

End If

Zahler = Zahler - 1
Wend

If Scrolldisplay = 1 Or Scrolldisplay = 2 Then
Locate 1 , 1
Lcd "                "
Locate 2 , 1
Lcd "                "
End If

Zahler4 = Komma8 - komma9
Zahler4 = Zahler4 - 1
Position1 = Komma8
Eingabestring2 = Right(eingabestring , Position1)
Suchergros1 = Left(eingabestring2 , Zahler4)
Genauigkeit = Val(suchergros1)


Zahler4 = Komma2 - komma3
Zahler4 = Zahler4 - 1
Position1 = Komma2
Eingabestring2 = Right(eingabestring , Position1)
Suchergros1 = Left(eingabestring2 , Zahler4)
Nordwert = Val(suchergros1)
Nordwert = Nordwert / 100
Nordwert_i = Int(nordwert)
Nordwert = Nordwert - nordwert_i
Nordwert = Nordwert * 100
Nordwert = Nordwert / 60
Nordwert = Nordwert + Nordwert_i
If Scrolldisplay = 1 Then
Locate 1 , 1
Lcd "N:"
Locate 1 , 3
Lcd "" ; Nordwert
End If



Zahler4 = Komma4 - komma5
Zahler4 = Zahler4 - 1
Position1 = Komma4
Eingabestring2 = Right(eingabestring , Position1)
Suchergros1 = Left(eingabestring2 , Zahler4)
Ostwert = Val(suchergros1)
Ostwert = Ostwert / 100
Ostwert_i = Int(ostwert)
Ostwert = Ostwert - ostwert_i
Ostwert = Ostwert * 100
Ostwert = Ostwert / 60
Ostwert = Ostwert + Ostwert_i
If Scrolldisplay = 1 Then
Locate 2 , 1
Lcd "E:"
Locate 2 , 3
Lcd "" ; Ostwert
End If


If Genauigkeit < Vorgabe_genauigkeit Then
If Arrayzahler = 1 Then
Wertschreiben = 1
End If
If Arrayzahler > 1 Then

Speicherzelle_pos2 = Speicherzelle_pos - 6
Call Singlelese(speicherzelle_pos2 , Ostwert2)
Ostwert2 = Ostwert - Ostwert2
Speicherzelle_pos2 = Speicherzelle_pos - 10
Call Singlelese(speicherzelle_pos2 , Nordwert2)
Nordwert2 = Nordwert - Nordwert2
'Lngen in Metern
Zwischenspeicher = Deg2rad(nordwert)
Laengenminute = 1852 * Cos(zwischenspeicher)
Ostwert2 = Ostwert2 * Laengenminute
'Umrechnen in Breitenminuten
Ostwert2 = Ostwert2 * 60
Real_versatz = Ostwert2 * Ostwert2
Nordwert2 = Nordwert2 * 1852
Nordwert2 = Nordwert2 * 60
Zwischenspeicher = Nordwert2 * Nordwert2
Zwischenspeicher = Zwischenspeicher + Real_versatz
Real_versatz = Sqr(zwischenspeicher)
If Real_versatz > Vorgabe_versatz Then
Wertschreiben = 1
Zurueckgelegte_strecke2 = Round(real_versatz)
Zurueckgelegte_strecke = Zurueckgelegte_strecke + Zurueckgelegte_strecke2

End If
End If
End If


'Uhrzeit
Zahler4 = 6
Position1 = Komma1
Eingabestring2 = Right(eingabestring , Position1)
Suchergros1 = Left(eingabestring2 , Zahler4)
Uhrzeit = Val(suchergros1)
'auf MEZ GMT+1 (Winter) oder GMT +2 (Sommer) einstellen
Uhrzeit = Uhrzeit + 20000
If Scrolldisplay = 1 Then
Locate 1 , 13
Lcd "    "
Locate 1 , 13
Lcd "" ; Uhrzeit
End If

If Scrolldisplay = 1 Then
Zahler4 = 4
Position1 = Komma9
Eingabestring2 = Right(eingabestring , Position1)
Suchergros1 = Left(eingabestring2 , Zahler4)
Locate 2 , 13
Lcd "" ; Suchergros1
End If

'Ausgabe der zurckgelegten Strecke
If Scrolldisplay = 2 Then
Locate 1 , 10
Lcd "A:" ; Arrayzahler

If Arrayzahler > 1 Then


Locate 2 , 1
If Zurueckgelegte_strecke > 10000 Then
Orts_versatz = Zurueckgelegte_strecke / 1000
Orts_versatz_i = Orts_versatz
Lcd "Strecke " ; Orts_versatz_i ; "km :"
Else
Orts_versatz_i = Zurueckgelegte_strecke
Lcd "Strecke " ; Orts_versatz_i ; "m"
End If

'Vergangene Zeit berechnen
Zwischenspeicher2 = Uhrzeit / 10000
Orts_versatz_i = Fix(zwischenspeicher2)
Ostwert3 = Orts_versatz_i * 60
Zwischenspeicher2 = Uhrzeit / 100
Zwischenspeicher2 = Round(zwischenspeicher2)
Orts_versatz_i = Orts_versatz_i * 100
Zwischenspeicher2 = Zwischenspeicher2 - orts_versatz_i
Ostwert3 = Zwischenspeicher2 + Ostwert3

Speicherzelle_pos2 = &H0010
Call Intlese(speicherzelle_pos2 , Uhrzeit_ar(1))
Zwischenspeicher2 = Uhrzeit_ar(1)
Zwischenspeicher2 = Zwischenspeicher2 / 100
Orts_versatz_i = Fix(zwischenspeicher2)
Nordwert3 = Orts_versatz_i * 60
Zwischenspeicher2 = Uhrzeit_ar(1)
Zwischenspeicher2 = Round(zwischenspeicher2)
Orts_versatz_i = Orts_versatz_i * 100
Zwischenspeicher2 = Zwischenspeicher2 - orts_versatz_i
Nordwert3 = Zwischenspeicher2 + Nordwert3

Orts_versatz_i = Ostwert3 - nordwert3
Locate 1 , 1
Lcd "T:" ; Orts_versatz_i ; "min"
End If
End If

If Scrolldisplay = 1 Then
Locate 1 , 12
Lcd "|"
Locate 2 , 12
Lcd "|"
End If

If Scrolldisplay = 2 Then
Locate 1 , 9
Lcd "|"
End If


'Der 24C512 hat insgesamt 65.536 Speicherstellen
'Diese gehen von &H0000 bis &HFFFF
'Beim Logger werden Zeit und Hoehe als Integer (je 2 Byte) und die Koordinaten als Single (je 4Byte) gespeichert
'Insgesamt sind dies 4+8 Bytes = 12 Bytes pro Aufnahme. Es knnen daher 5333 Aufnahmen gemacht werden - bei 100km sind dies alle 50 Meter ein Punkt

If Arrayzahler <= Eeprom_groesse Then
If Wertschreiben = 1 Then
'Umstellen auf PC-Verbindung

Waitms 250
Rxgps = 0
Txgps = 0
Rxpc = 1
Txpc = 1
Waitms 250
Print "PC-Datenausgabe"
Print "---------------"
Print "               "

'Uhrzeit
Uhrzeit = Uhrzeit / 100
Uhrzeit_ar(1) = Round(uhrzeit)
Print "Zeit: " ; Uhrzeit
If Speicherzelle = 1 Then
Call Intspeicher(speicherzelle_pos , Uhrzeit_ar(1))
Incr Speicherzelle_pos
Incr Speicherzelle_pos
End If


'Norden
Norden_ar(1) = Nordwert
Print "Nord_dez: " ; Nordwert
If Speicherzelle = 1 Then
Call Singlespeicher(speicherzelle_pos , Nordwert)
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos
End If


'Osten
Osten_ar(1) = Ostwert
Print "Ost: " ; Ostwert
If Speicherzelle = 1 Then
Call Singlespeicher(speicherzelle_pos , Ostwert)
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos
End If

'Hoehe
Zahler4 = Komma9 - komma10
Zahler4 = Zahler4 - 1
Position1 = Komma9
Eingabestring2 = Right(eingabestring , Position1)
Suchergros1 = Left(eingabestring2 , Zahler4)
Hoehe = Val(suchergros1)
Hoehe_ar(1) = Hoehe
Print "Hoehe: " ; Hoehe
If Speicherzelle = 1 Then
Call Intspeicher(speicherzelle_pos , Hoehe)
Incr Speicherzelle_pos
Incr Speicherzelle_pos
End If

Incr Arrayzahler
Wertschreiben = 0


If Speicherzelle = 1 Then
Speicherzellex_pos = Speicherzelle_pos
Zurueckgelegte_streckex = Zurueckgelegte_strecke
Arrayzahlerx = Arrayzahler
End If

Print "               "
Print "ENDE DATAOUT"
Print "---------------"
Waitms 500
End If

Else

If Eeprom_groesse > 0 Then
Locate 1 , 1
Lcd "*Speicher voll *"
End If
End If


'Anzeige des nchstgelegenen Orts
If Scrolldisplay = 3 Or Scrolldisplay = 4 Then

Ortszahler = 1
Orts_versatz_alt = 1000000000
Zahler3 = 1
Zahler5 = 1

While Zahler3 <= 59

Zahler5 = 1
Restore Nordkoordinate
While Zahler5 <= Zahler3
Read Nordwert3
Incr Zahler5
Wend


Zahler5 = 1
Restore Ostkoordinate
While Zahler5 <= Zahler3
Read Ostwert3
Incr Zahler5
Wend

Ostwert2 = Ostwert - Ostwert3
Nordwert2 = Nordwert - Nordwert3
'Lngen in Metern
Zwischenspeicher = Deg2rad(nordwert)
Laengenminute = 1852 * Cos(zwischenspeicher)
Ostwert2 = Ostwert2 * Laengenminute
'Umrechnen in Breitenminuten
Ostwert2 = Ostwert2 * 60
Real_versatz = Ostwert2 * Ostwert2
Nordwert2 = Nordwert2 * 1852
Nordwert2 = Nordwert2 * 60
Zwischenspeicher = Nordwert2 * Nordwert2
Zwischenspeicher = Zwischenspeicher + Real_versatz
Real_versatz = Sqr(zwischenspeicher)
If Real_versatz < Orts_versatz_alt Then
Orts_versatz = Real_versatz
Orts_versatz_alt = Orts_versatz
Ortszahler = Zahler3

End If
Incr Zahler3
Wend

Zahler5 = 1
Restore Ortsname
While Zahler5 <= Ortszahler
Read Eingabestring
Incr Zahler5
Wend

Locate 1 , 1
Lcd "                "
Locate 2 , 1
Lcd "                "

Locate 1 , 1

If Orts_versatz > 10000 Then
Orts_versatz = Orts_versatz / 1000
Orts_versatz_i = Orts_versatz
Lcd "Ort in " ; Orts_versatz_i ; "km :"
Else
Orts_versatz_i = Orts_versatz
Lcd "Ort in " ; Orts_versatz_i ; "m :"
End If

Locate 2 , 1
Lcd "" ; Eingabestring

Waitms 1000
' Da es sonst gleich wieder weg ist
End If


'Einstellen des aktuellen Displayinhalts Scrolldisplays
Eingestellt = 0
If Scrolldisplay = 1 Then
Scrolldisplay = 2
Eingestellt = 1
End If

If Scrolldisplay = 2 And Eingestellt = 0 Then
Scrolldisplay = 3
Eingestellt = 1
End If

If Scrolldisplay = 3 And Eingestellt = 0 Then
Scrolldisplay = 4
Eingestellt = 1
End If

If Scrolldisplay = 4 And Eingestellt = 0 Then
Scrolldisplay = 1
Eingestellt = 1
End If

If Eeprom_groesse = 0 Then
Scrolldisplay = 1
Eingestellt = 1
End If


End If
End If

If Schalter = 0 Then
Rxgps = 1
Txgps = 1
Rxpc = 0
Txpc = 0
'GPS_Schalter=1
Else
Rxgps = 0
Txgps = 0
Rxpc = 1
Txpc = 1
'GPS_Schalter=0
Waitms 2000
Locate 1 , 1
Lcd "                "
Locate 2 , 1
Lcd "                "
Locate 2 , 1
Lcd "****PC-Modus****"

Print "**********Konfigurationsmenue**********"
Print "*         -------------------         *"
Print "*                                     *"
Print "*            1 - Entwickler           *"
Print "*           2 - Datenausgabe          *"
Print "*           3 - Kalibrierung          *"
Print "*          4 - Softwarestand          *"
Print "*      5 - GPS-Maus durchschalten     *"
Print "*          6 - Hilfsprogramme         *"
Print "*         7 - Menue verlassen         *"
Print "*                                     *"
Print "*Nummer eingeben mit ENTER bestaetigen*"
Print "***************************************"

Input Eingabestring Noecho

If Eingabestring = "1" Then
Print "*            1 - Entwickler           *"
Print "*            --------------           *"
Print "*  Board entwickelt von Niels Keller  *"
Print "*   Keine Garantie/ Gewhrleistung    *"
Print "*         Experimentalstadium         *"
Print "*       Zusaetzliche Anmerkungen      *"
Print "*                                     *"
Eingabestring = Zusatzinformationx
Print "" ; Eingabestring
Print "*                                     *"
Print "*    Diesen Text aendern? (1 = ja)    *"
Input Eingabestring2 Noecho
If Eingabestring2 = "1" Then
Print "*Neuen Text eingeben (max. 40 Zeichen)*"
Input Eingabestring2 Noecho
Zusatzinformationx = Eingabestring2
Print "*      Zusatztext wurde geaendert     *"
End If
Print "*                                     *"
End If



If Eingabestring = "2" Then
If Arrayzahler = 1 Then
Print "Keine Daten vorhanden. Einstellen der Genauigkeit kann das Problem beheben."
End If
If Abgefragt = 0 Then
Abgefragt = 1
Zahler = 1
Speicherzelle_pos = &H0010
While Zahler < Arrayzahler
If Speicherzelle = 2 Then
Print "" ; Uhrzeit_ar(zahler) ; "   " ; Norden_ar(zahler) ; "   " ; Osten_ar(zahler) ; "   " ; Hoehe_ar(zahler)
Uhrzeit_ar(zahler) = 0
Norden_ar(zahler) = 0
Osten_ar(zahler) = 0
Hoehe_ar(zahler) = 0
Else
'Zeit
'nord
'ost
'hoehe

'Zeit
Call Intlese(speicherzelle_pos , Uhrzeit_ar(1))
Incr Speicherzelle_pos
Incr Speicherzelle_pos

'Nord
Call Singlelese(speicherzelle_pos , Nordwert)
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos

'Ost
Call Singlelese(speicherzelle_pos , Ostwert)
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos
Incr Speicherzelle_pos


'Hoehe
Call Intlese(speicherzelle_pos , Hoehe)
Incr Speicherzelle_pos
Incr Speicherzelle_pos

Print "" ; Uhrzeit_ar(1) ; "   " ; Nordwert ; "   " ; Ostwert ; "   " ; Hoehe

End If

Incr Zahler
Wend
Wertschreiben = 1
Arrayzahler = 1
Arrayzahlerx = Arrayzahler
Speicherzelle_pos = &H0010
Speicherzellex_pos = Speicherzelle_pos
Zurueckgelegte_strecke = 0
Zurueckgelegte_streckex = Zurueckgelegte_strecke
End If
End If

If Eingabestring = "3" Then
Print "*           3 - Kalibrierung          *"
Print "*           -----------------         *"
Print "*                                     *"
Vorgabe_versatz = Vorgabe_versatzx
Print "*Aktuelle Schrittweite: " ; Vorgabe_versatz ; "m*"
Print "*    Diesen Wert aendern? (1 = ja)    *"
Input Eingabestring2 Noecho
If Eingabestring2 = "1" Then
Print "*Neuen Wert eingeben (in Meter)*"
Input Eingabestring2 Noecho
Vorgabe_versatz = Val(eingabestring2)
Vorgabe_versatzx = Vorgabe_versatz
Print "*Neuer Wert: " ; Vorgabe_versatz ; "m"
Print "*         Wert wurde geaendert        *"
End If
Print "*                                     *"
Vorgabe_genauigkeit = Vorgabe_genauigkeitx
Print "*Aktuelle Genauigkeit: " ; Vorgabe_genauigkeit ; "m*"
Print "*    Diesen Wert aendern? (1 = ja)    *"
Input Eingabestring2 Noecho
If Eingabestring2 = "1" Then
Print "*Neuen Wert eingeben (in Meter)*"
Input Eingabestring2 Noecho
Vorgabe_genauigkeit = Val(eingabestring2)
Vorgabe_genauigkeitx = Vorgabe_genauigkeit
Print "*Neuer Wert: " ; Vorgabe_genauigkeit ; "m"
Print "*         Wert wurde geaendert        *"
End If

Eeprom_groesse = Eeprom_groesse_x
Print "*Aktuelle EEPROM-Groesse: " ; Eeprom_groesse ; " Messpunkte"
Eeprom_groesse = Eeprom_groesse * 12
Eeprom_groesse = Eeprom_groesse * 8
Print "*Groesse in Kilobit: " ; Eeprom_groesse ; " kBit"
Print "*    Diesen Wert aendern? (1 = ja)    *"
Input Eingabestring2 Noecho
If Eingabestring2 = "1" Then
Print "*Neuer Wert in Kbit*"
Input Eingabestring2 Noecho
Eeprom_groesse = Val(eingabestring2)
Eeprom_groesse_x = Eeprom_groesse
Print "*Neuer Groesse: " ; Eeprom_groesse ; " KBit"
Eeprom_groesse = Eeprom_groesse / 12
Eeprom_groesse = Eeprom_groesse / 8
Print "*Anzahl Messpunkte: " ; Eeprom_groesse ; ""
Eeprom_groesse_x = Eeprom_groesse
Print "*         Wert wurde geaendert        *"
Else
End If
Eeprom_groesse = Eeprom_groesse_x
End If

If Eingabestring = "4" Then
Print "*           4 - Softwarestand         *"
Print "*           -----------------         *"
Print "*                                     *"
Print "*        Version 0.3 - 60 Orte        *"
Print "*       Rottweil, den 03.08.2009      *"
Print "*                                     *"
End If


If Eingabestring = "5" Then
Print "*       5 - GPS-Maus durchschalten    *"
Print "*           -----------------         *"
Print "*Achtung! Beim Durchschalten wird das *"
Print "*Gert erst nach einem Umschalten in  *"
Print "*den GPS-Modus wieder funktionsfhig. *"
Print "*TX/ RX muss von Hand getauscht werden*"
Print "*      Durchschalten??? (1 = ja)      *"
Input Eingabestring2 Noecho
If Eingabestring2 = "1" Then
While Schalter = 1
Rxgps = 1
Txgps = 1
Rxpc = 1
Txpc = 1
'GPS_Schalter=1
Wend
End If
End If


If Eingabestring = "6" Then
Dim Inkrement As Byte
Dim Testinteger As Integer
Dim Testinteger2 As Integer
Dim Testsingle As Single
Dim Testsingle2 As Single


Test_ok = 1
Print "*Hilfsprogramme*"
Print "EEPROM-TEST - 1"
Print "Datenwiederherstellung - 2"

Input Eingabestring2 Noecho

If Eingabestring2 = "2" Then
Print "Datenwiederherstellung"
Print "Daten sind bis zum Abstellen wieder verfuegbar und koennen ueber Menuepunkt 2 gesichtet werden"
Arrayzahler = Eeprom_groesse
Abgefragt = 0
Print "Daten wurden wieder hergestellt"
End If

If Eingabestring2 = "1" Then
Print "***EEPROM-TEST**"
Print "----------------"
Print "***Inkrement?***"
Input Eingabestring2 Noecho
Inkrement = Val(eingabestring2)

Dat = 0
E_addr = &H0000
While E_addr < &H0010
Call E_write(e_addr , Dat)
Print "Gesendet: " ; Dat ; " "
Call E_read(e_addr , E_dat)
Print "Gelesen: " ; E_dat ; " "
If E_dat = Dat Then
Print "**Teiltest OK**"
Else
Test_ok = 0
End If
Dat = Dat + Inkrement
Incr E_addr
Wend

Print "**Test <<Speicherfunktion fuer Integer>>**"
Print "***Integer-Wert?***"
Input Eingabestring2 Noecho
Testinteger = Val(eingabestring2)

'Schreiben
Speicherzelle_pos = &H0010
Call Intspeicher(speicherzelle_pos , Testinteger)
Print "Geschrieben: " ; Testinteger

'Lesen
Speicherzelle_pos = &H0010
Call Intlese(speicherzelle_pos , Testinteger2)
Print "Gelesen: " ; Testinteger2

If Testinteger = Testinteger2 Then
Else
Test_ok = 0
End If

Print "**Test <<Speicherfunktion fuer Single>>**"
Print "***Single-Wert?***"
Input Eingabestring2 Noecho
Testsingle = Val(eingabestring2)

'Schreiben
Speicherzelle_pos = &H0010
Call Singlespeicher(speicherzelle_pos , Testsingle)
Print "Geschrieben: " ; Testsingle

'Lesen
Speicherzelle_pos = &H0010
Call Singlelese(speicherzelle_pos , Testsingle2)
Print "Gelesen: " ; Testsingle2

If Testsingle = Testsingle2 Then
Else
Test_ok = 0
End If


If Test_ok = 1 Then
Print "***EEPROM OK***"
Else
Print "**Fehlfunktion**"
End If

Print "**Test beendet**"
End If
End If


If Eingabestring = "7" Then
Print "* Zur Positionsanzeige GPS  aktivieren*"
End If

Waitms 500
End If

Loop
End

Sub E_write(byval E_addr As Word , Dat As Byte)
    E_ah = High(e_addr)
    E_al = Low(e_addr)
    I2cstart
    I2cwbyte E_ctlw
    I2cwbyte E_ah
    I2cwbyte E_al
    I2cwbyte Dat
    I2cstop
    Waitms 10
End Sub


' Routine to read the 24LC256
'
Sub E_read(byval E_addr As Word , E_dat As Byte)
    E_ah = High(e_addr)
    E_al = Low(e_addr)
    I2cstart
    I2cwbyte E_ctlw
    I2cwbyte E_ah
    I2cwbyte E_al
    I2cstart
    I2cwbyte E_ctlr
    I2crbyte E_dat , Nack
    I2cstop                                                 '
End Sub


Sub Intspeicher(byval Start_speicherzelle As Word , Intueber As Integer)
Int_wert = Intueber
S1 = Sbyte_int(1)
S2 = Sbyte_int(2)
E_addr = Start_speicherzelle
Dat = S1
Call E_write(e_addr , Dat)
Incr E_addr
Dat = S2
Call E_write(e_addr , Dat)
End Sub

Sub Intlese(byval Start_speicherzelle As Word , Intueber As Integer)
E_addr = Start_speicherzelle
Call E_read(e_addr , E_dat)
S1 = E_dat
Sbyte_int(1) = S1
Incr E_addr
Call E_read(e_addr , E_dat)
S2 = E_dat
Sbyte_int(2) = S2
Intueber = Int_wert
End Sub

Sub Singlespeicher(byval Start_speicherzelle As Word , Singleueber As Single)
Single_wert = Singleueber
S1 = Sbyte_single(1)
S2 = Sbyte_single(2)
S3 = Sbyte_single(3)
S4 = Sbyte_single(4)

E_addr = Start_speicherzelle
Dat = S1
Call E_write(e_addr , Dat)
Incr E_addr
Dat = S2
Call E_write(e_addr , Dat)
Incr E_addr
Dat = S3
Call E_write(e_addr , Dat)
Incr E_addr
Dat = S4
Call E_write(e_addr , Dat)
End Sub

Sub Singlelese(byval Start_speicherzelle As Word , Singleueber As Single)
E_addr = Start_speicherzelle
Call E_read(e_addr , E_dat)
S1 = E_dat
Sbyte_single(1) = S1
Incr E_addr
Call E_read(e_addr , E_dat)
S2 = E_dat
Sbyte_single(2) = S2
Incr E_addr
Call E_read(e_addr , E_dat)
S3 = E_dat
Sbyte_single(3) = S3
Incr E_addr
Call E_read(e_addr , E_dat)
S4 = E_dat
Sbyte_single(4) = S4
Singleueber = Single_wert
End Sub



'(
Ortsname:
Data "Helgoland" , "Rottweil"
Nordkoordinate:
Data 54.181676! , 48.162401!
Ostkoordinate:
Data 7.886306! , 8.611038!
')


 'Laenge der UC-Forum Version betrgt 59
Ortsname:
Data "Freiburg i. Br.","Rottweil","Singen Htwl","Konstanz","Muenchen","Regensburg","Nuernberg","Stuttgart","Pforzheim","Karlsruhe","Heidelberg","Wuerzburg","Frankfurt/ M.","Wiesbaden","Koblenz","Koeln","Bonn","Erfurt","Jena","Leipzig","Dresden","Dessau","Magdeburg","Wolfsburg","Braunschweig","Hannover","Kassel","Bielefeld","Bremen","Hamburg","Schwerin","Rostock","Berlin","Potsdam","Luebeck","Kiel","Bremerhaven","Wilhelmshaven","Oldenburg","Muenster","Dortmund","Essen","Duesseldorf","Duisburg","Marburg","Weimar","Eisenach","Gera","Chemnitz","Hof","Bamberg","Ingolstadt","Deggendorf","Augsburg","Ulm","Reutlingen","Tuebingen","Vill./ Schw.","Kaiserslautern","Siegen"

Nordkoordinate:
Data 47.996355!,48.175244!,47.761484!,47.662613!,48.129434!,49.009051!,49.439557!,48.756189!,48.897227!,49.009051!,49.400250!,49.802541!,50.110011!,50.081820!,50.345460!,50.937662!,50.732978!,50.975724!,50.927276!,51.340907!,51.044848!,51.839172!,52.126744!,52.422523!,52.264796!,52.372246!,51.313447!,52.022078!,53.077528!,53.553363!,53.628353!,54.085173!,52.529590!,52.399067!,53.865486!,54.326135!,53.533778!,53.514185!,53.130294!,51.954422!,51.505323!,51.454007!,51.227528!,51.423189!,50.802463!,50.972265!,50.968806!,50.875311!,50.826758!,50.324423!,49.887557!,48.759810!,48.828566!,48.363549!,48.400032!,48.491127!,48.523881!,48.052382!,49.439557!,50.857977!

Ostkoordinate:
Data 7.833252!,8.609161!,8.872833!,9.168091!,11.579590!,12.101440!,11.090698!,9.179077!,8.701172!,8.404541!,8.673706!,9.926147!,8.673706!,8.228760!,7.602539!,6.970825!,7.086182!,11.030273!,11.590576!,12.376099!,13.732910!,12.260742!,11.640015!,10.788574!,10.524902!,9.728394!,9.486694!,8.547363!,8.816528!,9.986572!,11.425781!,12.145386!,13.408813!,13.057251!,10.695190!,10.145874!,8.580322!,8.113403!,8.234253!,7.635498!,7.448730!,7.036743!,6.778564!,6.756592!,8.783569!,11.337891!,10.338135!,12.084961!,12.919922!,11.909180!,10.892944!,11.431274!,12.969360!,10.898438!,10.003052!,9.212036!,9.052734!,8.459473!,7.767334!,8.025513!
