function varargout = Oberflaeche(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Oberflaeche_OpeningFcn, ...
                   'gui_OutputFcn',  @Oberflaeche_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

function Oberflaeche_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;


guidata(hObject, handles);

function varargout = Oberflaeche_OutputFcn(hObject, eventdata, handles) 

varargout{1} = handles.output;


function pushbutton1_Callback(hObject, eventdata, handles)
global Fenster1;
global Fenster2;
global Fenster3;
global Fenster4;
global Ortschaften_zeigen;
global Fenster_zeigen
global Doppelplot

Ortspunkt_ost=load('-ascii','Ost.TXT');
Ortspunkt_nord=load('-ascii','Nord.TXT');
Ortspunkt_name=[{'Freiburg i. Br.','Rottweil','Singen Htwl','Konstanz','Muenchen','Regensburg','Nuernberg','Stuttgart','Pforzheim','Karlsruhe','Heidelberg','Wuerzburg','Frankfurt/ M.','Wiesbaden','Koblenz','Koeln','Bonn','Erfurt','Jena','Leipzig','Dresden','Dessau','Magdeburg','Wolfsburg','Braunschweig','Hannover','Kassel','Bielefeld','Bremen','Hamburg','Schwerin','Rostock','Berlin','Potsdam','Luebeck','Kiel','Bremerhaven','Wilhelmshaven','Oldenburg','Muenster','Dortmund','Essen','Duesseldorf','Duisburg','Marburg','Weimar','Eisenach','Gera','Chemnitz','Hof','Bamberg','Ingolstadt','Deggendorf','Augsburg','Ulm','Reutlingen','Tuebingen','Vill./ Schw.','Kaiserslautern','Siegen'}];
laenge=length(Ortspunkt_name);
laenge=length(Ortspunkt_ost);
laenge=length(Ortspunkt_nord)

[Daten,Pfad]=uigetfile('*.txt','GPS-Datensatz auswhlen','MultiSelect', 'on'); 
Daten=load('-ascii',[Pfad,Daten]);

Zeit=Daten(:,1);
norden=Daten(:,2);
osten=Daten(:,3);
hoehe=Daten(:,4);

zahler=1; 

while zahler<=length(osten)
if hoehe(zahler)==0
if zahler>=2 && zahler<length(osten)
if hoehe(zahler+1) ==0
hoehe(zahler)=hoehe(zahler-1);
else
hoehe(zahler)=(hoehe(zahler+1)+hoehe(zahler-1))/2;
end
end

if zahler==1
hoehe(zahler)=hoehe(zahler+1);
end

if zahler==length(osten)
hoehe(zahler)=hoehe(zahler-1);
end

end
zahler=zahler+1;
end

if Fenster_zeigen==0 
axes(Fenster1)
box(Fenster1,'off')
else
figure(1)
end
%Hier die Geenauigkeit des Meshs einstellen
schrittweite_n=(max(norden)-min(norden))/50;
schrittweite_o=(max(osten)-min(osten))/50;
ti_o = min(osten):schrittweite_o:max(osten);
ti_n = min(norden):schrittweite_n:max(norden);
[XI,YI] = meshgrid(ti_o,ti_n);
ZI = griddata(osten,norden,hoehe,XI,YI,'cubic');
mesh(XI,YI,ZI)
hold on
hoehe2=meshgrid(hoehe);
osten2=meshgrid(osten);
norden2=meshgrid(norden);
meshz(osten2,norden2,hoehe2);
plot3(osten,norden,hoehe,'LineWidth',5,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',5);
axis([min(osten)-0.001 max(osten)+0.001 min(norden)-0.001 max(norden)+0.001 min(hoehe) max(hoehe)])
xlabel('Osten')
ylabel('Norden')
zlabel('Hoehe')
title('Veranschaulichung in 3D')
if Ortschaften_zeigen==1
hoehe2=ones(laenge);
hoehe2=hoehe2(:,1)*max(min(hoehe));
plot3(Ortspunkt_ost,Ortspunkt_nord,hoehe2,'r+')
text(Ortspunkt_ost,Ortspunkt_nord,hoehe2,Ortspunkt_name,'VerticalAlignment','bottom','HorizontalAlignment','right','FontSize',8)
end
hold off

if Fenster_zeigen==0 
axes(Fenster2)
box(Fenster2,'off')

else
figure(2)
end
plot(osten,norden,'--rs','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',5)
axis([min(osten)-0.001 max(osten)+0.001 min(norden)-0.001 max(norden)+0.001])
hold on
xlabel('Osten')
ylabel('Norden')
title('Veranschaulichung des Weges')

if Ortschaften_zeigen==1
plot(Ortspunkt_ost,Ortspunkt_nord,'r+','LineWidth',2,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',10)
text(Ortspunkt_ost,Ortspunkt_nord,Ortspunkt_name,'VerticalAlignment','bottom','HorizontalAlignment','right','FontSize',12)
end
hold off

if Fenster_zeigen==0 
axes(Fenster3)
box(Fenster3,'off')

else
figure(3)
end
%Berechnung des Weges
zahler=1;
abstand=0;
while zahler<length(osten);
ostwert2=osten(zahler+1)-osten(zahler);
nordwert2=norden(zahler+1)-norden(zahler);
%Lngen in Metern
zwischenspeicher=(norden(zahler)*2*pi/360);
laengenminute=1852*cos(zwischenspeicher);
ostwert2=ostwert2*laengenminute;
%Umrechnen in Breitenminuten
ostwert2=ostwert2*60;
real_versatz=ostwert2*ostwert2;
nordwert2=nordwert2*1852;
nordwert2=nordwert2*60;
zwischenspeicher=nordwert2*nordwert2;
zwischenspeicher=zwischenspeicher+real_versatz;
abstand=[abstand;sqrt(zwischenspeicher)];
zahler=zahler+1;
end

%Aufaddieren des Weges
abstand2=zeros(length(abstand));
abstand_alt=0;
zahler=1;
while zahler<=length(abstand)
abstand2(zahler)=abstand_alt+abstand(zahler);
abstand_alt=abstand2(zahler);
zahler=zahler+1;
end
plot(abstand2/1000,hoehe,'Color','green','LineWidth',5);
axis([0 abstand2(length(abstand2))/1000 min(hoehe) max(hoehe)])
hold on
xlabel('Strecke [km]')
ylabel('Hoehe [m]')
title('Hoehenprofil')

%Hier weitermachen -  Zeit errechnen zusammen mit dem Abstand zur
%Geschwindigkeit v=abstand/t errechnen

%Ermitteln der aufgewandten Zeit - alles in Minuten umrechnen, die auf den
%Nullpunkt sprich 0h0min bezogen sind
%Zustzliche Variablen - was man eben so braucht
Zeit_i_min=zeros(length(Zeit));
Zeit_i_h=zeros(length(Zeit));
Zeit_zw=zeros(length(Zeit));
Geschwindigkeit=zeros(length(Zeit));


%Durch 100 teilen um auf Stunden zu kommen Bsp: 1340/100=13.40
Zeit_zw= Zeit/100;
%Abschneiden der Nachkommastellen 13.40->13.00
Zeit_i_h=fix(Zeit_zw);
%Multiplizieren mit 60 um von vollen Stunden auf Minuten zu kommen
%13.00*60=780 
Zeit_i_min=Zeit_i_h*60;

%Zeit durch 100 dividieren und runden --> 
%mit 100 multiplizieren und davon die eigentliche Zeit abziehen --> Extraktion der Minuten
Zeit=Zeit-Zeit_i_h*100+Zeit_i_min;
%Zeit liegt nun in Minuten vor und wird in Stunden umgerechnet
Zeit=Zeit-min(Zeit);

Zeitstuecke=0;
zahler=1;
while zahler<length(Zeit)
Zeitstuecke=[Zeitstuecke;Zeit(zahler+1)-Zeit(zahler)];
zahler=zahler+1; 
end

%In Zeitstuecke liegt der zeitliche Abstand in Minuten zwischen den einzelnen Datenpunkten
%Hier werden in Zeitstuecke2 alle Zeitstuecke, die 0 sind gefiltert und mit
%dem neuen Abtand3, der die Summe aus den Einzelstrecken ist, in einem
%Diagramm dargestellt
Zeitstuecke2=0;
Abstand3=0;
Abstandscounter=0;
zahler=1;
zahler2=1;
drinne=0;
Abstandscounter2=0;

while zahler<length(Zeit)
Zeitstuecke2=[Zeitstuecke2;Zeitstuecke(zahler2)];
Abstand3=[Abstand3;Abstandscounter2];
Abstandscounter=Abstandscounter+abstand(zahler);

if Zeitstuecke(zahler)==0  
else
  
  if drinne==0
  zahler4=1;
  while zahler4<=zahler+1;
  Zeitstuecke2(zahler4)=Zeitstuecke(zahler);
  zahler4=zahler4+1;
  end
  end
  drinne=1;

 zahler2=zahler;
 Abstandscounter2=0;
 Abstandscounter2=Abstandscounter;
 Abstandscounter=0;
end
zahler=zahler+1;
end


Zeitstuecke2=Zeitstuecke2/60;
Geschwindigkeit=(Abstand3/1000)./Zeitstuecke2;

if Fenster_zeigen==0 
else
figure(4)
axis([0 abstand2(length(abstand2))/1000 min(Geschwindigkeit) max(Geschwindigkeit)])
hold on
xlabel('Strecke [km]')
ylabel('Geschwindigkeit [km/h]')
title('Geschwindigkeitsprofil')
plot(abstand2/1000,Geschwindigkeit)
end

if Doppelplot==1
if Fenster_zeigen==0 
axes(Fenster3)
box(Fenster3,'off')
else
figure(3)
end    
[AX,H1,H2] = plotyy(abstand2/1000, hoehe,abstand2/1000, Geschwindigkeit,'plot');
set(get(AX(1),'Ylabel'),'String','Hoehe [m]') 
set(get(AX(2),'Ylabel'),'String','[Geschwindigkeit [km/h]]')
end


if Fenster_zeigen==0 
axes(Fenster4)
box(Fenster4,'off')
else
figure(5)
end

schrittweite_n=(max(norden)-min(norden))/50;
schrittweite_o=(max(osten)-min(osten))/50;
ti_o = min(osten):schrittweite_o:max(osten);
ti_n = min(norden):schrittweite_n:max(norden);
[XI,YI] = meshgrid(ti_o,ti_n);
ZI = griddata(osten,norden,Geschwindigkeit,XI,YI,'cubic');
mesh(XI,YI,ZI)
hold on
hoehe2=meshgrid(Geschwindigkeit);
osten2=meshgrid(osten);
norden2=meshgrid(norden);
meshz(osten2,norden2,hoehe2)
plot3(osten,norden,Geschwindigkeit,'LineWidth',5,'MarkerEdgeColor','k','MarkerFaceColor','g','MarkerSize',5);
axis([min(osten)-0.001 max(osten)+0.001 min(norden)-0.001 max(norden)+0.001 min(Geschwindigkeit) max(Geschwindigkeit)])
xlabel('Osten')
ylabel('Norden')
zlabel('Geschwindigkeit [km/h]')
title('Geschwindigkeitsverlauf')
if Ortschaften_zeigen==1
hoehe2=ones(laenge);
hoehe2=hoehe2(:,1)*max(min(hoehe));
plot3(Ortspunkt_ost,Ortspunkt_nord,hoehe2,'r+')
text(Ortspunkt_ost,Ortspunkt_nord,hoehe2,Ortspunkt_name,'VerticalAlignment','bottom','HorizontalAlignment','right','FontSize',8)
end
hold off

function axes1_CreateFcn(hObject, eventdata, handles)
global Fenster1;
Fenster1=hObject;

function axes3_CreateFcn(hObject, eventdata, handles)
global Fenster2;
Fenster2=hObject;

function axes4_CreateFcn(hObject, eventdata, handles)
global Fenster3;
Fenster3=hObject;

function axes5_CreateFcn(hObject, eventdata, handles)



function checkbox1_Callback(hObject, eventdata, handles)
global Ortschaften_zeigen
Ortschaften_zeigen=get(hObject,'Value');


function checkbox1_CreateFcn(hObject, eventdata, handles)
global Ortschaften_zeigen
Ortschaften_zeigen=get(hObject,'Value');

function axes7_CreateFcn(hObject, eventdata, handles)
global Fenster4;
Fenster4=hObject;

function checkbox2_Callback(hObject, eventdata, handles)
global Fenster_zeigen
Fenster_zeigen=get(hObject,'Value');

function checkbox2_CreateFcn(hObject, eventdata, handles)
global Fenster_zeigen
Fenster_zeigen=get(hObject,'Value');

function checkbox3_Callback(hObject, eventdata, handles)
global Fenster1;
rotate3d(Fenster1)

function checkbox4_Callback(hObject, eventdata, handles)
global Doppelplot
Doppelplot=get(hObject,'Value');

function checkbox4_CreateFcn(hObject, eventdata, handles)
global Doppelplot
Doppelplot=get(hObject,'Value');

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
[Daten,Pfad]=uigetfile('*.txt','Zu konvertierende Datei auswaehlen','MultiSelect', 'on');
Dateiname=Daten;
Daten=load('-ascii',[Pfad,Daten]);

Zeit=Daten(:,1);
norden=Daten(:,2);
osten=Daten(:,3);
hoehe=Daten(:,4);

zahler=1; 

while zahler<=length(osten)
if hoehe(zahler)==0
if zahler>=2 && zahler<length(osten)
if hoehe(zahler+1) ==0
hoehe(zahler)=hoehe(zahler-1);
else
hoehe(zahler)=(hoehe(zahler+1)+hoehe(zahler-1))/2;
end
end

if zahler==1
hoehe(zahler)=hoehe(zahler+1);
end

if zahler==length(osten)
hoehe(zahler)=hoehe(zahler-1);
end

end
zahler=zahler+1;
end

fid = fopen([Dateiname,'.gpx'], 'wt');
fprintf(fid,'%s \n','<gpx>');
fprintf(fid,'%s \n','<trk>');
fprintf(fid,'%s \n','<name>POSLOG V0.3</name>');
fprintf(fid,'%s \n','<trkseg>');

zahler=1; 
while zahler<=length(osten)
fprintf(fid,'%s','<trkpt lat="');
fprintf(fid,'%d',norden(zahler));
fprintf(fid,'%s','" lon="');
fprintf(fid,'%d',osten(zahler));
fprintf(fid,'%s \n','">');
fprintf(fid,'%s','<ele>');
fprintf(fid,'%d',hoehe(zahler));
fprintf(fid,'%s \n','</ele>');
fprintf(fid,'%s \n','</trkpt>');
zahler=zahler+1;
end
fprintf(fid,'%s \n','</trkseg>');
fprintf(fid,'%s \n',' </trk>');
fprintf(fid,'%s \n','</gpx>');
fclose(fid)